# Information zur Ordnerstruktur

Dieser Ordner besteht aus einer main Datei, die die `main` Funktion enthält, einem Ordner `include`
und einer `CMakeLists.txt` Datei, die den Kompiliervorgang automatisiert.

Der main Datei können Sie die möglichen Kommandozeilen Argumente entnehmen.

## Include

Dieser Ordner enthält die Programmlogik, die für die Simulation notwendig ist. In dem Unterordner `utilities` finden 
Sie bereits fertige Programmteile, die ohne weiteres zutun ihrerseits benutzt werden können. 

Zur Bearbeitung der Aufgabe müssen die Datein
- `leapfrog_scheme.hh`
- `nbody_acceleration.hh`
- `nbody.hh`
angepasst werden. Die Interfaces der auftretenden Klassen sind bereits zum Teil beschrieben, Teile die Sie anpassen 
müssen sind durch Kommentare gekennzeichnet.

# Kompilieren

Um das Programm zu kompilieren sollten Sie zunächst einen Ordner `build[_debug|release]` anlegen und danach in der 
Kommandozeile in diesen Ordner wechseln. Von dort aus erzeugen Sie sogennante `Makefiles` mit dem Befehl `cmake ..`.
Nachdem erfolgreichen ausführen kann das Programm mit `make` kompiliert werden, dies erzeugt eine ausführbare Datei
Names `nbody`. Nach Änderungen in `.hh` oder `.cc` Datein kann eine aktuelle Version wieder durch den Befehl `make` 
erzeugt werden.

Führen Sie `cmake` ohne Parameter aus, wird der C++ Kompiler mit Debug Optionen aufgerufen. Um den Kompiler Optimierungen
durchführen zu lassen, muss den `cmake` der Parameter `-DCMAKE_BUILD_TYPE=Release` übergeben werden. Der Aufruf sieht
damit wie folgt aus, `cmake -DCMAKE_BUILD_TYPE=Release ..`.

Sollten Sie Änderungen in der `CMakeLists.txt` vornehmen muss wieder im build Ordner der Befehl `cmake ..` ausgeführt
werden um die Änderungen zu übernehmen.